package furious;
import furious.*;
public class FuriousPOOL_SYS {
	public String TypeCNX="", Host="", Port="", Database="", User="", SYSOption="", Password="";
	int MaxPOOL=0, MaxWaitForNew=0;
	public FuriousCONNECTION_SYS[] Pool;

	public FuriousPOOL_SYS (String TypeCNX, String Host, String Port, String Database, 
			String User, String SYSOption, String Password, int MaxPOOL, int MaxWaitForNew) {
		this.TypeCNX=TypeCNX;
		this.Host=Host;
		this.Port=Port;
		this.Database=Database;
		this.User=User;
		this.SYSOption=SYSOption;
		this.Password=Password;
		this.MaxPOOL=MaxPOOL;
		this.MaxWaitForNew=MaxWaitForNew;
		this.Pool= new FuriousCONNECTION_SYS[MaxPOOL];
	}
	
	public synchronized FuriousCONNECTION_SYS GetFuriousConnection() throws Exception {
		boolean PasTrouve=true;
		FuriousCONNECTION_SYS CNXFuriousDisponible = null;
		long TimeDebut = System.currentTimeMillis();
		int iConnection=0, iNbConnection=this.Pool.length;
		if (this.MaxWaitForNew!=0) {
			while (PasTrouve && (System.currentTimeMillis()-TimeDebut)<=(this.MaxWaitForNew*1000)) {
				for(iConnection=0;iConnection<iNbConnection;iConnection++) {
					if (this.Pool[iConnection].Libre || !(this.Pool[iConnection].Valide)) {
						if (this.Pool[iConnection].CNX==null) {
							this.Pool[iConnection].NewCONNECTION(this.TypeCNX, this.Host, this.Port, this.Database, this.User, this.SYSOption, this.Password);
							CNXFuriousDisponible = this.Pool[iConnection];
							this.Pool[iConnection].Libre=false;
              this.Pool[iConnection].Valide=true;
							PasTrouve=false;
							break;
						} else {
							if (this.Pool[iConnection].isValide()) {
								CNXFuriousDisponible = this.Pool[iConnection];
								this.Pool[iConnection].Libre=false;
                this.Pool[iConnection].Valide=true;
								PasTrouve=false;
								break;
							} else {
								this.Pool[iConnection].NewCONNECTION(this.TypeCNX, this.Host, this.Port, this.Database, this.User, this.SYSOption, this.Password);
								CNXFuriousDisponible = this.Pool[iConnection];
								this.Pool[iConnection].Libre=false;
                this.Pool[iConnection].Valide=true;
								PasTrouve=false;
								break;
							}
						}
					}
				}
			}
			if (PasTrouve) throw new FuriousPOOLException_SYS("Time out for new connection ...");
		} else {
			while (PasTrouve) {
				for(iConnection=0;iConnection<iNbConnection;iConnection++) {
					if (this.Pool[iConnection].Libre || !(this.Pool[iConnection].Valide)) {
						if (this.Pool[iConnection].CNX==null) {
							this.Pool[iConnection].NewCONNECTION(this.TypeCNX, this.Host, this.Port, this.Database, this.User, this.SYSOption, this.Password);
							CNXFuriousDisponible = this.Pool[iConnection];
							this.Pool[iConnection].Libre=false;
              this.Pool[iConnection].Valide=true;
							PasTrouve=false;
							break;
						} else {
							if (this.Pool[iConnection].isValide()) {
								CNXFuriousDisponible = this.Pool[iConnection];
								this.Pool[iConnection].Libre=false;
                this.Pool[iConnection].Valide=true;
								PasTrouve=false;
								break;
							} else {
								this.Pool[iConnection].NewCONNECTION(this.TypeCNX, this.Host, this.Port, this.Database, this.User, this.SYSOption, this.Password);
								CNXFuriousDisponible = this.Pool[iConnection];
								this.Pool[iConnection].Libre=false;
                this.Pool[iConnection].Valide=true;
								PasTrouve=false;
								break;
							}
						}
					}
				}
			}
		}
		return CNXFuriousDisponible;
	}
}
